Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 70674 - net-irc/bnc: Buffer overflow vulnerability
Summary: net-irc/bnc: Buffer overflow vulnerability
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Security
Classification: Unclassified
Component: Vulnerabilities (show other bugs)
Hardware: All All
: High normal (vote)
Assignee: Gentoo Security
URL: http://www.gotbnc.com/changes.html
Whiteboard: B1 [glsa] lewk
Keywords:
Depends on:
Blocks:
 
Reported: 2004-11-10 08:30 UTC by Luke Macken (RETIRED)
Modified: 2004-11-16 02:16 UTC (History)
0 users

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Luke Macken (RETIRED) gentoo-dev 2004-11-10 08:30:45 UTC
TITLE:
BNC IRC proxy "getnickuserhost()" Buffer Overflow Vulnerability

SECUNIA ADVISORY ID:
SA13149

VERIFY ADVISORY:
http://secunia.com/advisories/13149/

CRITICAL:
Moderately critical

IMPACT:
DoS, System access

WHERE:
From remote

SOFTWARE:
BNC IRC proxy 2.x
http://secunia.com/product/1622/

DESCRIPTION:
Leon Juranic has reported a vulnerability in BNC IRC proxy, which can be exploited by malicious people to cause a DoS (Denial of Service) and potentially compromise a vulnerable system.

The vulnerability is caused due to some boundary errors in the "getnickuserhost()" function in "cmds.c" when processing IRC server responses. This can be exploited by a malicious server to cause a buffer overflow.

Successful exploitation crashes the process but may potentially also allow execution of arbitrary code.

The vulnerability has been reported in version 2.8.9. Other versions may also be affected.

SOLUTION:
Update to version 2.9.0:
http://www.gotbnc.com/files/bnc2.9.0.tar.gz

PROVIDED AND/OR DISCOVERED BY:
Leon Juranic

ORIGINAL ADVISORY:
http://security.lss.hr/en/index.php?page=details&ID=LSS-2004-11-03
Comment 1 Luke Macken (RETIRED) gentoo-dev 2004-11-10 08:33:07 UTC
Changelog:

2.9.1

   1. SECURITY FIX: password check, was only letting incorrect passwords in
   2. Fixed IP binding on listen 

2.9.0

   1. Added trailing newlines to log records
   2. Added extra error handling on accepting connections
   3. Fixed buffer overflow in getnickuserhost (reported by Leon Juranic)
   4. Added extra check for gethostbyname2
   5. Made password check more thorough
   6. Fixed ipv6 dns resolving to random ipv4 

===

This advisory is about the buffer overflow fix in 2.9.0, but 2.9.1 also fixes another security issue.


Vapier, please bump to 2.9.1.

Comment 2 SpanKY gentoo-dev 2004-11-10 12:13:33 UTC
2.9.1 is now in portage
Comment 3 Luke Macken (RETIRED) gentoo-dev 2004-11-10 15:04:11 UTC
archs, please mark stable.
Comment 4 Jason Wever (RETIRED) gentoo-dev 2004-11-10 20:32:30 UTC
Stable on sparc
Comment 5 Jochen Maes (RETIRED) gentoo-dev 2004-11-11 06:24:57 UTC
stable on ppc
Comment 6 Bryan Østergaard (RETIRED) gentoo-dev 2004-11-11 11:20:08 UTC
Stable on alpha.
Comment 7 Sune Kloppenborg Jeppesen gentoo-dev 2004-11-12 15:44:46 UTC
GLSA drafted Security please review.
Comment 8 Sune Kloppenborg Jeppesen gentoo-dev 2004-11-16 02:16:33 UTC
GLSA 200411-24